﻿Imports System.IO

Public Class Spelling
    Private list As LinkedList
    Public NotInheritable Class Word
        Private word As String

        Public Property IsCorrect() As Boolean
            Get
                Return _isCorrect
            End Get
            Private Set
                _isCorrect = Value
            End Set
        End Property
        Private _isCorrect As Boolean

        Friend Sub New(word As String, isCorrect As Boolean)
            Me.word = word
            _isCorrect = isCorrect
        End Sub

        Public Overrides Function ToString() As String
            Return word
        End Function
    End Class


    Public Sub New(reader As TextReader)
        list = New LinkedList()

        Dim word As String = reader.ReadLine()

        While word IsNot Nothing
            If Not word.StartsWith("%") Then
                list.Add(word.ToLower())
            End If
            word = reader.ReadLine()
        End While

        reader.Close()
    End Sub

    Public Function CheckWord(word As String) As Boolean
        Return list.Contains(word.ToLower())
    End Function

    Public Iterator Function CheckText(text As String) As IEnumerable
        Dim tokens = text.Split(New Char() {" "c, "."c, ","c, ":"c, ";"c,
                            ControlChars.Cr,
                            ControlChars.Lf},
                            StringSplitOptions.RemoveEmptyEntries)

        For Each token As String In tokens
            Yield New Word(token, list.Contains(token.ToLower()))
        Next
    End Function

End Class
